/*---------------------------------------------------------------------*/
/// CREOFF CURRENCY CALCULATOR
/// by Jos Deldime - jos.deldime@creoff.net (CreOFF 2009)
/// Uses some of the core features of the original VAT calculator by CreOFF.
///
/*--------------------

CHANGELOG:

v1.0
- the version that started it all

---------------------*/


/*---------------------------------------------------------------------*/
// Variables
/*---------------------------------------------------------------------*/
// Global library object. This must be valid for libraries to work!
var lib;
var theme;
var frmMain;
var lblPrompt1;
var lblPrompt2;
var lblVAT;
var lblPrompt4;
var cboCombo;
var cboImageCombo;
var pgbInstall;
var chkCheckBox;
var pgbInstall;
var txtTextBox;
var btnCancel;
//
var _currRate; // 
var _currPercentage;
var _currInputField;
var markerLine;

// make sure every recalculation is done with recent currency rate:
var updateInterval; // max time between last update of currency rate (in ms)
var _lastRateUpdate = new Date(); // latest update of the selected currency rate 
//
var vitalityDoc = XMLDOM.parse( filesystem.readFile("Source/vitality.xml") );
//
//
var app = {

	percentages: [],
	
	// based on currency code list: http://finance.yahoo.com/currency-converter
	currencies: [
					// A
					{name:'Albanian Lek', symbol:'ALL'},
					{name:'Algerian Dinar', symbol:'DZD'},
					{name:'Aluminium Ounces', symbol:'XAL'},
					{name:'Aruba Florin', symbol:'AWG'},
					{name:'Argentine Peso', symbol:'ARS'},
					{name:'Australian Dollar', symbol:'AUD'},
					// B
					{name:'British Pound', symbol:'GBP'},
					{name:'Bahraini Dinar', symbol:'BHD'},
					{name:'Barbados Dollar', symbol:'BBD'},
					{name:'Belize Dollar', symbol:'BZD'},
					{name:'Bhutan Ngultrum', symbol:'BTN'},
					{name:'Botswana Pula', symbol:'BWP'},
					{name:'Brunei Dollar', symbol:'BND'},
					{name:'Burundi Franc', symbol:'BIF'},
					{name:'Bahamian Dollar', symbol:'BSD'},
					{name:'Bangladesh Taka', symbol:'BDT'},
					{name:'Belarus Ruble', symbol:'BYR'},
					{name:'Bermuda Dollar', symbol:'BMD'},
					{name:'Bolivian Boliviano', symbol:'BOB'},
					{name:'Bulgarian Lev ', symbol:'BGN'},
					{name:'Brazilian Real', symbol:'BRL'},
					// C
					{name:'Cambodia Riel', symbol:'KHR'},
					{name:'Canadian Dollar', symbol:'CAD'},
					{name:'Cayman Islands Dollar', symbol:'KYD'},
					{name:'CFA Franc (BEAC)', symbol:'XAF'},
					{name:'Colombian Peso', symbol:'COP'},
					{name:'Copper Pounds', symbol:'XCP'},
					{name:'Croatian Kuna', symbol:'HRK'},
					{name:'Cyprus Pound', symbol:'CYP'},
					{name:'Chinese Yuan', symbol:'CNY'},
					{name:'Cape Verde Escudo', symbol:'CVE'},
					{name:'CFA Franc (BCEAO)', symbol:'XOF'},
					{name:'Chilean Peso', symbol:'CLP'},
					{name:'Comoros Franc', symbol:'KMF'},
					{name:'Costa Rica Colon', symbol:'CRC'},
					{name:'Cuban Peso', symbol:'CUP'},
					{name:'Czech Koruna', symbol:'CZK'},
					// D-F
					{name:'Euro', symbol:'EUR'},
					{name:'Djibouti Franc', symbol:'DJF'},
					{name:'East Carribean Dollar', symbol:'XCD'},
					{name:'Egyptian Pound', symbol:'EGP'},
					{name:'Eritrea Nakfa', symbol:'ERN'},
					{name:'Ethiopian Birr', symbol:'ETB'},
					{name:'Fiji Dollar', symbol:'FJD'},
					{name:'Danish Krone', symbol:'DKK'},
					{name:'Domenican Peso', symbol:'DOP'},
					{name:'Ecuador Sucre', symbol:'ECS'},
					{name:'El Salvador Colon', symbol:'SVC'},
					{name:'Estonian Kroon', symbol:'EEK'},
					{name:'Falkland Islands Pounds', symbol:'FKP'},
					// G-I
					{name:'Hong Kong Dollar', symbol:'HKD'},
					{name:'Indian Rupee', symbol:'INR'},
					{name:'Ghanian Cedi', symbol:'GHC'},
					{name:'Gold Ounces', symbol:'XAU'},
					{name:'Guinea Franc', symbol:'GNF'},
					{name:'Haiti Gourde', symbol:'HTG'},
					{name:'Hungarian Forint', symbol:'HUF'},
					{name:'Iran Rial', symbol:'IRR'},
					{name:'Israeli Shekel', symbol:'ILS'},
					{name:'Indonesian Rupiah', symbol:'IDR'},
					{name:'Gambian Dalasi', symbol:'GMD'},
					{name:'Gibraltar Pound', symbol:'GIP'},
					{name:'Guatemala Quetzal', symbol:'GTQ'},
					{name:'Guyana Dollar', symbol:'GYD'},
					{name:'Honduras Lempira', symbol:'HNL'},
					{name:'Iceland Krona', symbol:'ISK'},
					{name:'Iraqi Dinar', symbol:'IQD'},
					// J-L
					{name:'Japanese Yen', symbol:'JPY'},
					{name:'Jordanian Dinar', symbol:'JOD'},
					{name:'Kenyan Shilling', symbol:'KES'},
					{name:'Kuwaiti Dinar', symbol:'KWD'},
					{name:'Latvian Lat', symbol:'LVL'},
					{name:'Lesotho Loti', symbol:'LSL'},
					{name:'Libyan Dinar', symbol:'LYD'},
					{name:'Jamaican Dollar', symbol:'JMD'},
					{name:'Kazakhstan Tenge', symbol:'KZT'},
					{name:'Korean Won', symbol:'KRW'},
					{name:'Lao Kip', symbol:'LAK'},
					{name:'Lebanese Pound', symbol:'LBP'},
					{name:'Liberian Dollar', symbol:'LRD'},
					{name:'Lithuanian Lita', symbol:'LTL'},
					// M
					{name:'Macau Pataca', symbol:'MOP'},
					{name:'Malawi Kwacha', symbol:'MWK'},
					{name:'Maldives Rufiyaa', symbol:'MVR'},
					{name:'Mauritania Ougulya', symbol:'MRO'},
					{name:'Mexican Peso', symbol:'MXN'},
					{name:'Mongolian Tugrik', symbol:'MNT'},
					{name:'Myanmar Kyat', symbol:'MMK'},
					{name:'Macedonian Denar', symbol:'MKD'},
					{name:'Malaysian Ringgit', symbol:'MYR'},
					{name:'Maltese Lira', symbol:'MTL'},
					{name:'Mauritius Rupee', symbol:'MUR'},
					{name:'Moldovan Leu', symbol:'MDL'},
					{name:'Moroccan Dirham', symbol:'MAD'},
					// N-O
					{name:'Namibian Dollar', symbol:'NAD'},
					{name:'Neth Antilles Guilder', symbol:'ANG'},
					{name:'Nicaragua Cordoba', symbol:'NIO'},
					{name:'North Korean Won', symbol:'KPW'},
					{name:'Omani Rial', symbol:'OMR'},
					{name:'Nepalese Rupee', symbol:'NPR'},
					{name:'New Zealand Dollar', symbol:'NZD'},
					{name:'Nigerian Naira', symbol:'NGN'},
					{name:'Norwegian Krone', symbol:'NOK'},
					// P-R
					{name:'Renminbi', symbol:'CNY'},
					{name:'Pakistani Rupee', symbol:'PKR'},
					{name:'Panama Balboa', symbol:'PAB'},
					{name:'Paraguayan Guarani', symbol:'PYG'},
					{name:'Philippine Peso', symbol:'PHP'},
					{name:'Polish Zloty', symbol:'PLN'},
					{name:'Romanian New Leu', symbol:'RON'},
					{name:'Rwanda Franc', symbol:'RWF'},
					{name:'Pacific Franc', symbol:'XPF'},
					{name:'Palladium Ounces', symbol:'XPD'},
					{name:'Papua New Guinea Kina', symbol:'PGK'},
					{name:'Peruvian Nuevo Sol', symbol:'PEN'},
					{name:'Platinum Ounces', symbol:'XPT'},
					{name:'Qatar Rial', symbol:'QAR'},
					{name:'Russian Rouble', symbol:''},
					// S
					{name:'Swiss Franc', symbol:'CHF'},
					{name:'Sao Tome Dobra', symbol:'STD'},
					{name:'Seychelles Rupee', symbol:'SCR'},
					{name:'Silver Ounces', symbol:'XAG'},
					{name:'Slovak Koruna', symbol:'SKK'},
					{name:'Solomon Islands Dollar', symbol:'SBD'},
					{name:'South African Rand', symbol:'ZAR'},
					{name:'St Helena Pound', symbol:'SHP'},
					{name:'Swaziland Lilageni', symbol:'SZL'},
					{name:'Syrian Pound', symbol:'SYP'},
					{name:'Samoa Tala', symbol:'WST'},
					{name:'Saudi Arabian Riyal', symbol:'SAR'},
					{name:'Sierra Leone Leone', symbol:'SLL'},
					{name:'Singapore Dollar', symbol:'SGD'},
					{name:'Slovenian Tolar', symbol:'SIT'},
					{name:'Somali Shilling', symbol:'SOS'},
					{name:'Sri Lanka Rupee', symbol:'LKR'},
					{name:'Sudanese Dinar', symbol:'SDD'},
					{name:'Swedish Krona', symbol:'SEK'},
					// T-U
					{name:'US Dollar', symbol:'USD'},
					{name:'Turkish Lira', symbol:'TRY'},
					{name:'Tanzanian Shilling', symbol:'TZS'},
					{name:'Trinidad & Tobago Dollar', symbol:'TTD'},
					{name:'UAE Dirham', symbol:'AED'},
					{name:'Ukraine Hryvnia', symbol:'UAH'},
					{name:'Thai Bath', symbol:'THB'},
					{name:'Taiwan Dollar', symbol:'TWD'},
					{name:'Tonga Pa\'anga', symbol:'TOP'},
					{name:'Tunisian Dinar', symbol:'TND'},
					{name:'Ugandan Shilling', symbol:'UGX'},
					{name:'Uruguayan New Peso', symbol:'UYU'}
					
				],
				
	selected_currencies: [],

	init: function() {
		print("init app");
		app.initPrefs();
	},

	/***
	* do some extra stuff with the prefs to check for validity
	*/
	initPrefs: function() {
		print("initPrefs");
		
		var temp = parseInt(preferences.updateInterval.value,10) ;
		temp = (temp>5) ? temp : 5; // minimum 5 mins
		updateInterval = temp * 60 * 1000;
		log ("update interval set at "+temp+" mins");
		app.initSelectedCurrencies();

	},
	
	
	initDropdowns: function() {
		
		cboCombo.items.clear();
		cboCombo2.items.clear();
		
		cboCombo.selectedIndex = -1;
		cboCombo2.selectedIndex = -1;
		
		for (var i=0; i<app.selected_currencies.length; i++) { // add currencies
			log ('adding '+app.selected_currencies[i].name);
			cboCombo.items.add(" "+app.selected_currencies[i].name+" ");
			cboCombo2.items.add(" "+app.selected_currencies[i].name+" ");
		}
		
		// add extra option:
		cboCombo.items.add("-");
		cboCombo.items.add(" "+widget.getLocalizedString("add_currency")+" ");
		cboCombo2.items.add("-");		
		cboCombo2.items.add(" "+widget.getLocalizedString("add_currency")+" ");
		
		cboCombo.selectedIndex = 0;
		cboCombo2.selectedIndex = 1;
		
	},
	
	
	initSelectedCurrencies: function() {
		
		var temp= preferences.selectedCurrencies.value.split(",");
		log ("default currencies: "+temp);
		
		// clear selected:
		app.selected_currencies = new Array();
		
		for (var i=0; i<temp.length; i++) {
			var currency = app.lookupCurrency(temp[i]);
			if (currency) {
				// store the postion in the main currencies array:
				currency.listIndex = currency.index;
				app.selected_currencies.push(currency);
			} 
			log("found "+currency.name);
		}
	},
	
	/**
	 * reset both dropdowns to first element:
	 */
	resetDropdowns: function() {
		log("preferences.currency1.value: "+preferences.currency1.value);
		var currency = app.lookupCurrency(preferences.currency1.value,app.selected_currencies);
		log (currency.index);
		cboCombo.selectedIndex = (!currency) ? 0 : currency.index;
		
		var currency = app.lookupCurrency(preferences.currency2.value,app.selected_currencies);
		cboCombo2.selectedIndex = (!currency) ? 0 : currency.index;
				
	},

	toggleWindowSize:function() {
		log("minmaximize");

		if (frmMain.height == frmMain.minimizedHeight) {
			app.fullsizeWindow(); // restore to normal height
		} else {
			app.minimizeWindow(); // minimize:
		}

		doLayout();

	},

	fullsizeWindow: function() {
		//
		frmMain._form_setSize( frmMain.maxWidth, frmMain.maxHeight);
		minMax.src = "Resources/images/FormButtonMin.png";
		minMax.tooltip = widget.getLocalizedString("minimize");
		frmMain.text = " "+widget.getLocalizedString("Common.Application.Title");
	},

	minimizeWindow: function() {
		frmMain._form_setSize( frmMain.minWidth, frmMain.minimizedHeight);
		minMax.src = "Resources/images/FormButtonMax.png";
		minMax.tooltip = widget.getLocalizedString("restore");
		frmMain.text = " "+widget.getLocalizedString("Common.Application.shortTitle"); // shorter title as well ;-)
	},


	/**
	* Calculates starting from VAT exclusive
	*/
   calcField: function(fieldObj) {
		var retVal = 0; // default value is 0
		if (fieldObj.text!="") { // evaluate result
			var temp = new String(fieldObj.text);
			temp = temp.replace(/,/g, "\.") // swap decimal comma for decimal point if present
			//remove leading zeros from answer:
			while (temp.charAt(0)=="0") { temp=temp.substring(1,temp.length);} if (temp.charAt(0)==".") temp="0"+temp;
			eval("var temp = Number("+temp+");"); if (!isNaN(temp)) retVal = temp; // evaluate this formula
		}
		return app.round(retVal);
	},
	
	/**
	 * look up symbol from text (uses currencies array)
	 * @param {s} string
	 * returns symbol as string
	 */
    lookupSymbol: function(sName) {
		var i=0; 
		var symbol=false;
		sName = sName.replace(/^\s*|\s*$/g,''); // remove leading and trailing spaces
		while (i<app.currencies.length && symbol==false) { 
			if (app.currencies[i].name==sName) symbol = app.currencies[i].symbol;
			i++;
		}
		return symbol;
	},
	
	
	/**
	 * look up array index from symbok (uses currencies array)
	 * @param {sSymbol} string with symbol (e.g. "EUR")
	 * returns object in array
	 */
    lookupCurrency: function(sSymbol, currArray) {
		var i=0; 
		var found=false;
		if (currArray==undefined) currArray = app.currencies;
		while (i<currArray.length && !found) { // lookup one by one
			if (currArray[i].symbol == sSymbol) {
				found = currArray[i];
				found.index = i;
			}
			i++;
		}
		return found;
	},

   recalc: function(sender,e) {

		var now = new Date();
		var timeLapse = now.getTime() - _lastRateUpdate.getTime(); // time since last update (in ms)
		if (timeLapse > updateInterval) {
			// update latest update rate to NOW
			log ("--update rate now--");
			_lastRateUpdate = new Date(); // now			
			app.updateCurrentRate();			
		}		
		// log ("time since last update: "+(now.getTime()-_lastRateUpdate.getTime()));
				
		_startAmount = app.calcField(sender);
		_currPercentage = parseFloat(cboCombo.items.item(cboCombo.selectedIndex))/100;

		switch (sender.id) {
			case "txtVATExcl":  // _startAmount = exclusive value
								txtVATincl.text = app.round(_startAmount * _currRate);
								arrow.hOffset = 10; arrow.vOffset = 60; arrow.rotation = 0;
								break;
			case "txtVATincl":    // inclusive value
								temp =  _startAmount / _currRate; // calc exclusive value
								txtVATExcl.text = app.round(temp);
								arrow.hOffset = 10; arrow.vOffset = _currInputField.top+28; arrow.rotation = 180;
								break;			
		}
	},

	onPrefsChanged: function() {
		reloadWidget(); // for now the quick & easy way: just reload the widget
	},

	main: function() {
		var lang;

		var locale = widget.locale;
		if ( locale.substr( 0, 2 ) == "en" )  print( "English locale" );
		print (locale);
		//var welcome = widget.getLocalizedString("welcome_msg");
		//print ("welcome: "+welcome);

		// Includes
		//lib.include("Yahoo.Resources.ResourceManager");
		lib.include("Yahoo.Drawing.ContentAlignment");
		lib.include("Yahoo.Drawing.Common");
		lib.include("Yahoo.EventArgs");
		lib.include("Yahoo.Controls.Theme");
		lib.include("Yahoo.Controls.Control");
		lib.include("Yahoo.Controls.SizableControlBase");
		lib.include("Yahoo.Controls.Sizable3PartControlBase");
		lib.include("Yahoo.Controls.Label");
		lib.include("Yahoo.Controls.Button");
		lib.include("Yahoo.Controls.ComboBox");
		lib.include("Yahoo.Controls.TextBox");
		lib.include("Yahoo.Controls.CheckedListBox");
		lib.include("Yahoo.Controls.Form");

		// Create a named theme
		theme = new Yahoo.Controls.Theme(lib.getClassResourcePath("Yahoo.Controls") + "/Themes");
		theme.loadTheme("Black Glass");
		// Optionally you could use the default theme by passing null to a control such as Form
		//theme = null;

		// Listen to theme changed events
		theme.addEventHandler(theme_onThemeChanged, "ThemeChanged")

		// Create controls
		frmMain = new Yahoo.Controls.Form(theme);
		frmMain.text = " "+widget.getLocalizedString("Common.Application.Title");
		frmMain.width = 270;
		frmMain.height = 170;
		frmMain.minWidth = frmMain.width - 40;
		frmMain.minimizedHeight = 52;
		frmMain.maxWidth = frmMain.width;
		frmMain.maxHeight = frmMain.height;
		frmMain.closeBox = false;

		frmMain.formBorderStyle = Yahoo.Controls.FormBorderStyle.Fixed;
		frmMain.minimumSize = new Yahoo.Drawing.Size(frmMain.minWidth, frmMain.minimizedHeight);
		frmMain.maximumSize = new Yahoo.Drawing.Size(frmMain.maxWidth,frmMain.maxHeight);
		frmMain.addEventHandler(frmMain_onClosing, "Closing");
		frmMain.addEventHandler(frmMain_onClosed, "Closed");

		var _startY = 34;
		var _startX = 30;
		var _lineSpacing = 10; // pixels inbetween text fields vertically
		var _horSpacing = 10; // pixels inbetween text fields horizontally
		var _labelOffset = 4; // pixel offset to textfield

		// Add markerLine
		markerLine = new Image();
		markerLine.src = "Resources/images/line.png";
		markerLine.zOrder = 1;
		markerLine.vRegistrationPoint = 0;

		txtVATExcl = new Yahoo.Controls.TextBox(frmMain.theme);
		txtVATExcl.text = "1";
		txtVATExcl.id = "txtVATExcl";
		txtVATExcl.left = _startX;
		txtVATExcl.top = _startY;
		txtVATExcl.width = 200;
		txtVATExcl.height = 21;

		inputField_onTextChanged = function(sender, e) {
			if (sender.id==_currInputField.id) {
				log("inputField_onTextChanged");
				app.recalc(sender,e);
			}
		}
		
		inputField_onKeyPress = function(sender, e) {
			// allow characters: 0-9 and '.+-/*()' only:

			var key = system.event.key; var keyString = system.event.keyString;
			var shift = system.event.shiftKey;

			print("you pressed key: "+key);
			print("you pressed keyString: "+keyString);

			//if ((key.charCodeAt(0) >= "0".charCodeAt(0) && key.charCodeAt(0) <= "9".charCodeAt(0))
			// make more OS X compatible (for Apple iBook caps lock belgian keyboard)
			if ( (key >= "0" && key <= "9")
				|| key.charCodeAt(0) == ".".charCodeAt(0)
				|| key.charCodeAt(0) == ",".charCodeAt(0)
				|| keyString=="Backspace" || keyString=="Delete"
				|| key.charCodeAt(0) == "*".charCodeAt(0)
				|| key.charCodeAt(0) == "+".charCodeAt(0)
				|| key.charCodeAt(0) == "-".charCodeAt(0)
				|| key.charCodeAt(0) == "/".charCodeAt(0)
				|| key.charCodeAt(0) == "(".charCodeAt(0)
				|| key.charCodeAt(0) == ")".charCodeAt(0)
				){
				changeCurrentField(sender); // change _currInputField

			} else {

				sender._txtTextBox.rejectKeyPress();

				if (keyString == 'Tab') {

					if (shift) {
						switch(_currInputField.id) {
						case "txtVATExcl": newField = txtVAT; break;
						case "txtVATincl": newField = txtVATExcl; break;
						// case "txtVAT": newField = txtVATincl; break;
						}

					} else {
						switch(_currInputField.id) {
						case "txtVATExcl": newField = txtVATincl; break;
						case "txtVATincl": newField = txtVAT; break;
						// case "txtVAT": newField = txtVATExcl; break;
						}
					}

					_currInputField._txtTextBox.loseFocus(); // for Mac OSX
					_currInputField._txtTextBox.select(-1, -1); // for Mac OSX
					newField._txtTextBox.focus();
					newField._txtTextBox.select(0,-1);
					changeCurrentField(newField);

				}  else {
					print("invalid key press (must be digit from 0 to 9))");


					if (keyString=="Enter" || keyString=="Return" ) {
						print ("**** calc this value");
						sender.text = app.calcField(sender);
					} // end if Enter

				} // end if TAB

			  } // end if keyCode



		} // end inputField_onKeyPress

		changeCurrentField = function(newField) {
			// set currentfield from oldField to newField
			// (also changes images)
			if (_currInputField) _currInputField.arrow.src = "Resources/images/arrow_off.png"; // set old arrow to OFF
			_currInputField = newField; // remember current input field (will be master)
			_currInputField.arrow.src = "Resources/images/arrow_on.png"; // set new arrow to ON
			//
			// show markerline underneath:
			markerLine.hOffset = _currInputField.left+4;
			markerLine.vOffset = _currInputField.top+48;
		}

		inputField_onClick = function(sender, e) {
			log("inputField_onClick");
			_currInputField._txtTextBox.loseFocus(); // for Mac OSX
			_currInputField._txtTextBox.select(-1, -1); // for Mac OSX

			sender._txtTextBox.focus();
			sender._txtTextBox.select(0,-1);
			changeCurrentField(sender); // change _currInputField
		}

		txtVATExcl.addEventHandler(inputField_onTextChanged, "TextChanged");
		txtVATExcl.addEventHandler(inputField_onKeyPress, "KeyPress");


			// Add arrow
		txtVATExcl.arrow = new Image();
		txtVATExcl.arrow.parent = "txtVATExcl";
		txtVATExcl.arrow.src = "Resources/images/arrow_off.png";
		txtVATExcl.arrow.hOffset = txtVATExcl.left + txtVATExcl.width + 16 ;
		txtVATExcl.arrow.vOffset = txtVATExcl.top + txtVATExcl.height + 16 + 4;
		txtVATExcl.arrow.vRegistrationPoint = 8;
		txtVATExcl.arrow.rotation = 180;

		arrow_onClick = function() {
			log("arrow_onClick");
			// do same as click on text box (will select text as well)
			Yahoo.raiseEvent(eval(this.parent), [inputField_onClick], {cancel:false} );
		}

		arrow_over = function() {
			this.src = "Resources/images/arrow_over.png";
			this.tooltip = widget.getLocalizedString("arrow_tooltip");
		}

		arrow_out = function() {
			if (this.parent == _currInputField.id) this.src = "Resources/images/arrow_on.png";
			else this.src = "Resources/images/arrow_off.png";
		}

		txtVATExcl.arrow.onClick = arrow_onClick;
		txtVATExcl.arrow.onMouseEnter = arrow_over;
		txtVATExcl.arrow.onMouseExit = arrow_out;
		
		txtVATincl = new Yahoo.Controls.TextBox(frmMain.theme);
		txtVATincl.text = "";
		txtVATincl.id = "txtVATincl";
		txtVATincl.left = txtVATExcl.left;
		txtVATincl.top = txtVATExcl.top + 34 ;
		txtVATincl.width = 200;
		txtVATincl.height = 21;

		txtVATincl.arrow = new Image();
		txtVATincl.arrow.parent = "txtVATincl";
		txtVATincl.arrow.src = "Resources/images/arrow_off.png";
		txtVATincl.arrow.hOffset = txtVATincl.left + txtVATincl.width + 16 ;
		txtVATincl.arrow.vOffset = txtVATincl.top + txtVATincl.height + 16 + 4;
		txtVATincl.arrow.vRegistrationPoint = 8;
		txtVATincl.arrow.rotation = 180;
		// events
		txtVATincl.arrow.onClick = arrow_onClick;
		txtVATincl.arrow.onMouseEnter = arrow_over;
		txtVATincl.arrow.onMouseExit = arrow_out;

		txtVATincl.addEventHandler(inputField_onTextChanged, "TextChanged");
		txtVATincl.addEventHandler(inputField_onKeyPress, "KeyPress");
		
		// first combobox
		cboCombo = new Yahoo.Controls.ComboBox(frmMain.theme);
		cboCombo.addEventHandler(cboCombo_onSelectedIndexChanged, "SelectedIndexChanged");
		cboCombo.left = txtVATExcl.left;
		cboCombo.id = "CURR_A";
		cboCombo.width = txtVATExcl.width;
		cboCombo.height = 24;
		// cboCombo.top = txtVATExcl.top + txtVATExcl.height + _lineSpacing - 1;
		cboCombo.top = txtVATExcl.top - cboCombo.height - _labelOffset;

		// second combobox
		cboCombo2 = new Yahoo.Controls.ComboBox(frmMain.theme);
		cboCombo2.addEventHandler(cboCombo_onSelectedIndexChanged, "SelectedIndexChanged");
		cboCombo2.left = txtVATincl.left;
		cboCombo2.top = txtVATincl.top + txtVATincl.height + 3;
		cboCombo2.id = "CURR_B";
		cboCombo2.width = txtVATincl.width;
		cboCombo2.height = 24;
		
		// init dropdown values to selected currencies
		app.initDropdowns();
		
		txtVATExcl._txtTextBox.tooltip = widget.getLocalizedString("tooltip_currency") + cboCombo.items.item(cboCombo.selectedIndex);
		txtVATincl._txtTextBox.tooltip = widget.getLocalizedString("tooltip_currency") + cboCombo.items.item(cboCombo2.selectedIndex);
		
	   	// reset dropdowns
		app.resetDropdowns();

		cboCombo.toolTip = widget.getLocalizedString("choose_currency");
		cboCombo2.toolTip = widget.getLocalizedString("choose_currency");

		// Add all to main form
		// Add controls
		frmMain.addControl(cboCombo);
		frmMain.addControl(cboCombo2);
		frmMain.addControl(txtVATExcl);
		frmMain.addControl(txtVATincl);
		
		// make VATexcl the default input field at startup:
		changeCurrentField(txtVATExcl); // change _currInputField

		// Add visual
		visual = new Image();
		visual.src = "Resources/images/visual.png";
		/* visual.left = 0;
		visual.top = 50; */
		visual.zOrder = 0;
		//visual.hAlign="left";
		visual.vAlign="top";
		visual.vRegistrationPoint = 0;
		visual.clipRect = "0, 0, 200, 160";

		// Add arrow
		arrow = new Image();
		arrow.src = "Resources/images/arrow_off.png";
		arrow.hOffset = 10;
		arrow.vOffset = 60;
		arrow.vRegistrationPoint = 16;
		arrow.zOrder = 2;
		arrow.tooltip = widget.getLocalizedString("arrow_tooltip");

		// Add min/max button
		minMax = new Image();
		minMax.src = "Resources/images/FormButtonMin.png";
		minMax.hOffset = 10;
		minMax.vOffset = 6;
		minMax_onClick = function() {
			log("minMax_onClick");
			app.toggleWindowSize();
		}
		minMax.onClick = minMax_onClick;
		minMax.tooltip = widget.getLocalizedString("minimize");
		minMax.zOrder = 2;
		frmMain.frame.window.appendChild( minMax );
		frmMain.frame.window.appendChild( txtVATExcl.arrow );
		frmMain.frame.window.appendChild( txtVATincl.arrow );
		frmMain.frame.window.appendChild( markerLine );
		frmMain.frame.window.appendChild( visual );

		doLayout();
		app.recalc(txtVATExcl,txtVATExcl.text);

		frmMain.show();

	},
	
	updateCurrentRate: function(e) {
		
		log ("updating Current Rate");
		
		var currency = new String(cboCombo.items.item(cboCombo.selectedIndex));
		var firstCurrency = app.lookupSymbol(currency);
		var secondCurrency = app.lookupSymbol(cboCombo2.items.item(cboCombo2.selectedIndex));
		
		log ("firstCurrency: "+currency+" "+firstCurrency);
		log ("secondCurrency: "+cboCombo2.items.item(cboCombo2.selectedIndex)+" "+secondCurrency);
		
		var url = new URL();
		webAddress = "http://download.finance.yahoo.com/d/quotes.csv?s=";
		webAddress += firstCurrency + secondCurrency;
		webAddress += "=X&f=sl1d1t1ba&e=.csv";
		
		try {
	        contents = url.fetch(webAddress);
	    } catch( e ) {
	        contents = "Could not load URL";
	    }
		
		var currency = app.lookupCurrency(app.currencies[cboCombo.selectedIndex].symbol);
		log("webAddress: " + webAddress);
		
		if (contents.indexOf("Could not load URL") > -1) {
			alert("Couldn't download Currency. Please try again later.");
			
		} else {
			// if an error occurs and fetch() is returning a string, then it returns the string “Could not load URL”
			
			// returns a CSV comma separated list as a string
			contents = contents.split(",");
			// we only need second in array:
			_currRate = contents[1];
			log("_currRate = " + _currRate);
			
			app.recalc(_currInputField, e);
			preferences.currency1.value = firstCurrency;
			preferences.currency2.value = secondCurrency;
			
			log("set prefs to: " + firstCurrency + " and " + secondCurrency);
		}
	},
	
	showCurrencyList: function() {
		
		frmCurrencies = new Yahoo.Controls.Form(theme);
		frmCurrencies.text = " "+widget.getLocalizedString("tit_select_currencies");
		//frmCurrencies.text = " Select currencies to use:";
		
		// put it exactly over the existing widget:
		frmCurrencies.left = frmMain.left;
		frmCurrencies.top = frmMain.top ;
		frmCurrencies.width = frmMain.width;
		frmCurrencies.height = frmMain.height + 100;
		
		frmCurrencies.minWidth = frmCurrencies.width - 40;
		frmCurrencies.minimizedHeight = 52;
		frmCurrencies.maxWidth = frmCurrencies.width;
		frmCurrencies.maxHeight = frmCurrencies.height;
		frmCurrencies.closeBox = true;

		frmCurrencies.formBorderStyle = Yahoo.Controls.FormBorderStyle.Fixed;
		frmCurrencies.minimumSize = new Yahoo.Drawing.Size(frmCurrencies.minWidth, frmCurrencies.minimizedHeight);
		frmCurrencies.maximumSize = new Yahoo.Drawing.Size(frmCurrencies.maxWidth,frmCurrencies.maxHeight);
		
		frmCurrencies.addEventHandler(frmCurrencies_onClosing, "Closing");
		// frmCurrencies.addEventHandler(frmMain_onClosed, "Closed");
		
		var _startX = 10;		
		var _startY = 0;
		
		clbList = new Yahoo.Controls.CheckedListBox(frmCurrencies.theme);
		
		clbList.items.addRange(new Array(widget.getLocalizedString("loading_currencies")));
		
		clbList.left = _startX;
		clbList.top = _startY;
		
		clbList.width = 240;
		clbList.height = 190;
		
		btnOK = new Yahoo.Controls.Button(frmCurrencies.theme);
		btnOK.text = widget.getLocalizedString("select_currencies");
		btnOK.width = clbList.width;
		btnOK.height = 26;
		btnOK.top = _startY + clbList.height + 4;
		btnOK.left = _startX;
		
		btnOK.addEventHandler(btnOK_onClick, "Click");
		
		frmCurrencies.addControl(clbList);
		
		frmCurrencies.show();
		
		var names = new Array();
		for (var i=0; i<app.currencies.length; i++) { 
			names.push(app.currencies[i].name);
		}

		// Add items
		clbList.items.clear();
		clbList.items.addRange(names);
	
		// Check the already selected currencies in list:
		for (var i=0; i<app.selected_currencies.length; i++) {
			log ("activate row index "+app.selected_currencies[i].listIndex);
			clbList.setItemChecked(app.selected_currencies[i].listIndex, true);
		}
		
		// add OK button
		frmCurrencies.addControl(btnOK);
		
	},
	
	round: function(value,precision) {
		if (typeof(precision) == "undefined") precision = parseInt(preferences.precision.value,10);
		var temp = Number(value);
		temp = temp.toFixed(precision);
		return temp;
	}

};


/*---------------------------------------------------------------------*/
// Control code
/*---------------------------------------------------------------------*/
/**
 * Startup code for the widget.
 */
function widget_onLoad() {

	var libraryPath;
	var libraryFile;

	// Verify that our library is where we expect it to be.
	//
	//libraryPath = system.userWidgetsFolder + "/Library";
	// libraryFile = libraryPath + "/LibraryShared.js"; // use this one in case the classes library is shared (ie not included in each widget)
	//
	libraryPath = "Resources/Library";
	libraryFile = libraryPath + "/Library.js";	
	// log("libraryfile: "+libraryFile);
	
	if(filesystem.itemExists(libraryFile) == true) {
		include(libraryFile);
		lib = new Yahoo.Utility.Library(libraryPath);
		app.init();
		app.main();
	}
	else {
		alert("This widget requires components from the Widget Class Library.\n\nPlease verify that the required files been successfully installed in the My Widgets folder.");
	}
}

/**
 * Handles theme onThemeChanged event.
 */
function theme_onThemeChanged(sender, e) {

	log("theme_onThemeChanged");

	// Set theme on main form
	frmMain.theme = sender;
}

/**
 * Handles onClosing event for form.
 */
function frmMain_onClosing(sender, e) {
	log("frmMain_onClosing");
}

/**
 * Handles onClosing event for form.
 */
function frmCurrencies_onClosing(sender, e) {
	log("*** frmCurrencies_onClosing");
	app.resetDropdowns();
	hide_frmCurrencies();
}

function btnOK_onClick(sender,e) {
	log ("clicked on OK button - save currencies");
	// frmCurrencies.closeBox();
	btnOK.text = "One moment, please...";
	
	if (clbList.checkedIndices.length < 2) {
		// ERROR: needs minimum two currencies selected
		alert("You need to select at least two currencies");
		
	} else {
		log("indexes:" + clbList.checkedIndices);
		// store indexes
		var symbolArray = new Array();
		for (var i = 0; i < clbList.checkedIndices.length; i++) {
			log("store " + app.currencies[clbList.checkedIndices[i]].symbol);
			symbolArray.push(app.currencies[clbList.checkedIndices[i]].symbol);
		}
		// store in preferences: preferences.selectedCurrencies.value = "EUR,USD,PHP";
		preferences.selectedCurrencies.value = symbolArray.join(",");
		log("selected currency prefs saved: " + preferences.selectedCurrencies.value);
		
		// re-initialize selected currencies array:
		app.initSelectedCurrencies();
		// re-initialize dropdowns:	
		app.initDropdowns();
		
		hide_frmCurrencies();
	}
}

/**
 * hide elements on frmCurrencies 
 * (apparently they dont disappear automatically when closing the form?)
 */
function hide_frmCurrencies() {
	
	clbList.hide();
	btnOK.hide();
	frmCurrencies.dispose();		
}


/**
 * Handles onClosed event for form.
 */
function frmMain_onClosed(sender, e) {

	log("frmMain_onClosed");
	doClose();
}

/**
 * Handles onResize event for form.
 */
function frmMain_onResize(sender, e) {

	log("frmMain_onResize");
	doLayout();
}

/**
 * Handles cboCombo_onSelectedIndexChanged event for a combobox.
 */
function cboCombo_onSelectedIndexChanged(sender, e) {
	
	log("sender: "+sender.id);
	log("cboCombo_onSelectedIndexChanged ");
	log("cboCombo "+cboCombo.selectedIndex);
	
	log("cboCombo selected: "+cboCombo.items.item(cboCombo.selectedIndex));
	
	log("cboCombo2 "+cboCombo2.selectedIndex);
	
	if (sender.selectedIndex >= app.selected_currencies.length) {
		log("SHOW CURRENCY SELECTION SCREEN");
		
		app.showCurrencyList();
		// var a = new FadeAnimation( _currInputField, 0, 350, animator.kEaseOut);
		// animator.start( a );
		
	} else {		
		app.updateCurrentRate(e); // e = symbol?
				
	} // end if 
}








/*---------------------------------------------------------------------*/
// Private code
/*---------------------------------------------------------------------*/
/**
 * Closes the widget.
 */
function doClose() {
	//closeWidget();
	//widget.visible = false;
}

/**
 * Does a layout of the controls on the form.
 */
function doLayout() {
	minMax.hOffset = frmMain.clientSize.width - minMax.width ;
}

function setVitality(doFade)
{
	transition = "";
	if (typeof doFade != "undefined" && doFade) {
		transition = "fade";
	}

	if ( !widget.dockOpen ) return;
	var doc = vitalityDoc;
	widget.setDockItem(doc,transition);
}

